## libbloom 1.5

=== Makefile ===
#
# Copyright (c) 2012-2017, Jyri J. Virkki
# All rights reserved.
#
# This file is under BSD license. See LICENSE file.
#
# By default, builds optimized 64bit libbloom (under ./build)
# Requires GNU Make, so invoke appropriately (make or gmake)
#
# Other build options:
#
#   DEBUG=1 make        to build debug instead of optimized
#   BITS=32 make        to build 32bit library
#   BITS=default make   to build platform default bitness (32 or 64)
#
# Other build targets:
#
#   make test           to build and run test code
#   make release_test   to build and run larger tests
#   make gcov           to build with code coverage and run gcov
#   make clean          the usual
#

BLOOM_VERSION_MAJOR=1
BLOOM_VERSION_MINOR=5
BLOOM_VERSION=$(BLOOM_VERSION_MAJOR).$(BLOOM_VERSION_MINOR)

TOP := $(shell /bin/pwd)
BUILD_OS := $(shell uname)

BUILD=$(TOP)/build
INC=-I$(TOP) -I$(TOP)/murmur2
LIB=-lm
COM=${CC} $(CFLAGS) $(CPPFLAGS) -Wall ${OPT} ${MM} -std=c99 -fPIC -DBLOOM_VERSION=$(BLOOM_VERSION)
TESTDIR=$(TOP)/misc/test

ifeq ($(BITS),)
MM=-m64
else ifeq ($(BITS),64)
MM=-m64
else ifeq ($(BITS),32)
MM=-m32
else ifeq ($(BITS),default)
MM=
else
MM=$(BITS)
endif

#
# Shared library names - these definitions work on most platforms but can
# be overridden in the platform-specific sections below.
#
BLOOM_SONAME=libbloom.so.$(BLOOM_VERSION_MAJOR)
SO_VERSIONED=libbloom.so.$(BLOOM_VERSION)
LD_SONAME=-Wl,-soname,$(BLOOM_SONAME)
SO=so


ifeq ($(BUILD_OS),$(filter $(BUILD_OS), GNU/kFreeBSD GNU Linux))
RPATH=-Wl,-rpath,$(BUILD)
endif

ifeq ($(BUILD_OS),SunOS)
RPATH=-R$(BUILD)
CC=gcc
endif

ifeq ($(BUILD_OS),OpenBSD)
RPATH=-R$(BUILD)
endif

ifeq ($(BUILD_OS),Darwin)
MAC=-install_name $(BUILD)/libbloom.dylib \
	-compatibility_version $(BLOOM_VERSION_MAJOR) \
	-current_version $(BLOOM_VERSION)
RPATH=-Xlinker -rpath -Xlinker $(BUILD)
SO=dylib
BLOOM_SONAME=libbloom.$(BLOOM_VERSION_MAJOR).$(SO)
SO_VERSIONED=libbloom.$(BLOOM_VERSION).$(SO)
LD_SONAME=
endif

ifeq ($(DEBUG),1)
OPT=-g $(DEBUGOPT)
else
OPT=-O3
endif


all: $(BUILD)/$(SO_VERSIONED) $(BUILD)/libbloom.a

$(BUILD)/$(SO_VERSIONED): $(BUILD)/murmurhash2.o $(BUILD)/bloom.o
	(cd $(BUILD) && \
	    $(COM) $(LDFLAGS) bloom.o murmurhash2.o -shared $(LIB) $(MAC) \
		$(LD_SONAME) -o $(SO_VERSIONED) && \
		rm -f $(BLOOM_SONAME) && ln -s $(SO_VERSIONED) $(BLOOM_SONAME) && \
		rm -f libbloom.$(SO) && ln -s $(BLOOM_SONAME) libbloom.$(SO))

$(BUILD)/libbloom.a: $(BUILD)/murmurhash2.o $(BUILD)/bloom.o
	(cd $(BUILD) && ar rcs libbloom.a bloom.o murmurhash2.o)

$(BUILD)/test-libbloom: $(TESTDIR)/test.c $(BUILD)/$(SO_VERSIONED)
	$(COM) -I$(TOP) -c $(TESTDIR)/test.c -o $(BUILD)/test.o
	(cd $(BUILD) && \
	    $(COM) test.o -L$(BUILD) $(RPATH) -lbloom -o test-libbloom)

$(BUILD)/test-basic: $(TESTDIR)/basic.c $(BUILD)/libbloom.a
	$(COM) -I$(TOP) $(LIB) \
	    $(TESTDIR)/basic.c $(BUILD)/libbloom.a -o $(BUILD)/test-basic

$(BUILD)/%.o: %.c
	mkdir -p $(BUILD)
	$(COM) $(INC) -c $< -o $@

$(BUILD)/murmurhash2.o: murmur2/MurmurHash2.c murmur2/murmurhash2.h
	mkdir -p $(BUILD)
	$(COM) $(INC) -c murmur2/MurmurHash2.c -o $(BUILD)/murmurhash2.o

clean:
	rm -rf $(BUILD)

test: $(BUILD)/test-libbloom $(BUILD)/test-basic
	$(BUILD)/test-basic
	$(BUILD)/test-libbloom

vtest: $(BUILD)/test-libbloom
	valgrind --tool=memcheck --leak-check=full --show-reachable=yes \
	    $(BUILD)/test-libbloom

gcov:
	$(MAKE) clean
	DEBUG=1 DEBUGOPT="-fprofile-arcs -ftest-coverage" \
	    $(MAKE) $(BUILD)/test-libbloom
	(cd $(BUILD) && \
	    cp ../*.c . && \
	    ./test-libbloom && \
	    gcov -bf bloom.c)
	@echo Remember to make clean to remove instrumented objects

#
# This target runs a test which creates a filter of capacity N and inserts
# N elements, for N in 100,000 to 1,000,000 with an expected error of 0.001.
# To preserve and graph the output, move it to ./misc/collisions and use
# the ./misc/collisions/dograph script to plot it.
#
# WARNING: This can take a very long time (on a slow machine, multiple days)
# to run.
#
collision_test: $(BUILD)/test-libbloom
	$(BUILD)/test-libbloom -G 100000 1000000 10 0.001 \
	    | tee collision_data_v$(BLOOM_VERSION)

#
# This target should be run when preparing a release, includes more tests
# than the 'test' target.
# For a final release, should run the collision_test target above as well,
# not included here as it takes so long.
#
release_test:
	$(MAKE) test
	$(MAKE) vtest
	$(BUILD)/test-libbloom -G 100000 1000000 50000 0.001 \
	    | tee short_coll_data
	gzip short_coll_data
	./misc/collisions/dograph short_coll_data.gz

=== debian/changelog ===
libbloom (1.5-1) unstable; urgency=medium

  * New upstream version 1.5 (Closes: #862769)
  * debian/patches:
    - Remove backported patches.
  * debian/copyright:
    - Update the copyright year.

 -- Roger Shimizu <rogershimizu@gmail.com>  Sat, 10 Jun 2017 00:50:27 +0900

libbloom (1.4-6) unstable; urgency=medium

  * Fix the typo of bug number in previous release (1.4-5).
  * debian/patches:
    - Amend previous patch (0004) that still FTBFS on Hurd.
      (Closes: #860506).

 -- Roger Shimizu <rogershimizu@gmail.com>  Tue, 16 May 2017 18:52:18 +0900

libbloom (1.4-5) unstable; urgency=medium

  * debian/patches:
    - Amend previous patch (0004) that FTBFS on buildd all ARCHs.
      (Closes: #860506, #862445).

 -- Roger Shimizu <rogershimizu@gmail.com>  Sat, 13 May 2017 10:53:19 +0900

libbloom (1.4-4) unstable; urgency=medium

  * debian/patches:
    - Add patch to extend RPATH setting to GNU/kFreeBSD and Hurd.
      Hopefully to fix FTBFS issue on the two platforms.

 -- Roger Shimizu <rogershimizu@gmail.com>  Fri, 12 May 2017 23:39:46 +0900

libbloom (1.4-3) unstable; urgency=medium

  * debian/copyright:
    - Move the paragraph of MIT/Expat license to the right position.
      Text copy of MIT/Expat license is from debmake package:
        /usr/share/debmake/extra4/Expat
  * debian/control:
    - Add collab-maint Vcs repo.
  * debian/rules:
    - Fix Multi-Arch triplet directory.
      Install library files into /usr/lib/${DEB_TARGET_MULTIARCH}
      directory, instead of /usr/lib/${DEB_TARGET_GNU_TYPE}.
      Should be the right triplet directory this time.
  * debian/watch:
    - Add a missing quotes mark after the equal mark. Now uscan
      command can work as expected.

 -- Roger Shimizu <rogershimizu@gmail.com>  Fri, 21 Apr 2017 22:28:08 +0900

libbloom (1.4-2) unstable; urgency=medium

  * debian/patches:
    - backport a patch from upstream to enable BITS setting.
  * debian/rules:
    - Set BITS=default when building/testing according to upstream's
      advice:
        https://github.com/jvirkki/libbloom/issues/6
      Apparently the BITS setting (-m32/-m64) is merely for solaris,
      so we simply ignore this in debian.

 -- Roger Shimizu <rogershimizu@gmail.com>  Thu, 13 Apr 2017 01:22:07 +0900

libbloom (1.4-1) unstable; urgency=low

  * Initial release (Closes: #858026).

 -- Roger Shimizu <rogershimizu@gmail.com>  Mon, 20 Mar 2017 17:09:44 +0900

=== debian/control ===
Source: libbloom
Section: libs
Priority: optional
Maintainer: Roger Shimizu <rogershimizu@gmail.com>
Build-Depends: debhelper (>= 10)
Standards-Version: 3.9.8
Homepage: https://github.com/jvirkki/libbloom
Vcs-Git: https://anonscm.debian.org/git/collab-maint/libbloom.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libbloom.git

Package: libbloom-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libbloom1 (= ${binary:Version}),${misc:Depends}
Description: simple and small bloom filter implementation in C (development files)
 It implements bloom filters:
  http://en.wikipedia.org/wiki/Bloom_filter
 .
 This package provides C header files for the library.

Package: libbloom1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: simple and small bloom filter implementation in C
 It implements bloom filters:
  http://en.wikipedia.org/wiki/Bloom_filter
 .
 This package provides shared library.

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libbloom-$1.tar.gz%" \
   https://github.com/jvirkki/libbloom/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## libbloom 1.6

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (c) 2012-2017, Jyri J. Virkki
+# Copyright (c) 2012-2019, Jyri J. Virkki
 # All rights reserved.
 #
 # This file is under BSD license. See LICENSE file.
@@ -22,7 +22,7 @@
 #
 
 BLOOM_VERSION_MAJOR=1
-BLOOM_VERSION_MINOR=5
+BLOOM_VERSION_MINOR=6
 BLOOM_VERSION=$(BLOOM_VERSION_MAJOR).$(BLOOM_VERSION_MINOR)
 
 TOP := $(shell /bin/pwd)
@@ -104,9 +104,14 @@
 	(cd $(BUILD) && \
 	    $(COM) test.o -L$(BUILD) $(RPATH) -lbloom -o test-libbloom)
 
+$(BUILD)/test-perf: $(TESTDIR)/perf.c $(BUILD)/$(SO_VERSIONED)
+	$(COM) -I$(TOP) -c $(TESTDIR)/perf.c -o $(BUILD)/perf.o
+	(cd $(BUILD) && \
+	    $(COM) perf.o -L$(BUILD) $(RPATH) -lbloom -o test-perf)
+
 $(BUILD)/test-basic: $(TESTDIR)/basic.c $(BUILD)/libbloom.a
-	$(COM) -I$(TOP) $(LIB) \
-	    $(TESTDIR)/basic.c $(BUILD)/libbloom.a -o $(BUILD)/test-basic
+	$(COM) -I$(TOP) \
+	    $(TESTDIR)/basic.c $(BUILD)/libbloom.a $(LIB) -o $(BUILD)/test-basic
 
 $(BUILD)/%.o: %.c
 	mkdir -p $(BUILD)
@@ -123,6 +128,9 @@
 	$(BUILD)/test-basic
 	$(BUILD)/test-libbloom
 
+perf: $(BUILD)/test-perf
+	$(BUILD)/test-perf
+
 vtest: $(BUILD)/test-libbloom
 	valgrind --tool=memcheck --leak-check=full --show-reachable=yes \
 	    $(BUILD)/test-libbloom
@@ -136,6 +144,14 @@
 	    ./test-libbloom && \
 	    gcov -bf bloom.c)
 	@echo Remember to make clean to remove instrumented objects
+
+lcov: gcov
+	lcov --capture --directory build --output-file lcov.info
+	lcov --remove lcov.info xxhash.c --output-file lcov.info
+	genhtml lcov.info --no-branch-coverage \
+		--output-directory $(LCOV_OUTPUT_DIR)
+	rm -f lcov.info
+	$(MAKE) clean
 
 #
 # This target runs a test which creates a filter of capacity N and inserts

=== debian/changelog ===
libbloom (1.6-6) unstable; urgency=medium

  * debian/patches:
    - Update patch 02 no to fail if there's no valgrind installed.

 -- Roger Shimizu <rosh@debian.org>  Sun, 05 Sep 2021 20:08:52 +0900

libbloom (1.6-5) unstable; urgency=medium

  * debian/control & debian/tests/control:
    - Add restrict of B-D for valgrind (Closes: #993614).
      Thanks to Adrian Bunk for raising this issue.
  * debian/patches:
    - Update patch 01 to output that the test is by shared library,
      not static one.
    - Update patch 02 to check valgrind command availability before
      invoking.

 -- Roger Shimizu <rosh@debian.org>  Sun, 05 Sep 2021 17:04:53 +0900

libbloom (1.6-4) unstable; urgency=medium

  * debian/patches:
    - Add a patch for autopkgtest, or CI pipeline:
        autopkgtest-Use-system-library-to-run-test.patch
      It uses system's include and library, and skip to build local
      library.
    - Add patch 02 to add verbose log of valgrind output.
  * debian/tests/upstream-test-suite:
    - Apply the patch above.
    - Use "make release_test" instead of "make test" to run the test.
  * debian/tests/control:
    - Install build-essential and library for the test.
  * debian/upstream/metadata:
    - Remove Homepage entry to make lintian happy.
  * debian/control & debian/tests/control:
    - In order to perform more tests, add to B-D: ploticus, valgrind
  * debian/rules:
    - Use "make release_test" for dh_auto_test.

 -- Roger Shimizu <rosh@debian.org>  Sat, 04 Sep 2021 00:26:06 +0900

libbloom (1.6-3) unstable; urgency=medium

  * debian/control and debian/copyright:
    - Update to use my debian email.
    - Update URL of upstream.
  * debian/control:
    - Bump policy version to 4.5.0 (no change).
  * Add debian/upstream/metadata
  * debian/rules:
    - Clean up security hardening.
  * debian/libcorkipset1.symbols:
    - Add Build-Depends-Package as requested by lintian.

 -- Roger Shimizu <rosh@debian.org>  Wed, 20 May 2020 01:27:36 +0900

libbloom (1.6-2) unstable; urgency=medium

  * Team upload.
  * debian/libbloom1.symbols: Add new symbol.
  * debian/control:
    + Bump debhelper compat to v12.
    + Bump Standards-Version to 4.4.1.

 -- Boyuan Yang <byang@debian.org>  Sun, 13 Oct 2019 13:58:15 -0400

libbloom (1.6-1) unstable; urgency=medium

  * New upstream release: 1.6
    - Added a simple bloom_reset() function.
    - Performance boost on membership test if element not present.
    - Test cleanup and coverage.
  * debian/control:
    - Use tracker mail as maintainer address.
  * debian/patches:
    - Refresh patch: 0001

 -- Roger Shimizu <rogershimizu@gmail.com>  Sat, 17 Aug 2019 19:24:43 +0900

libbloom (1.5-5) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #923264)
    + Let dh_auto_build pass cross tools to make.
    + Honour DEB_BUILD_OPTIONS=nocheck.
    + Fix host/target confusion.
    + Let dpkg's architecture.mk initialize DEB_HOST_MULTIARCH.

 -- Roger Shimizu <rogershimizu@gmail.com>  Thu, 21 Mar 2019 14:14:36 +0900

libbloom (1.5-4) unstable; urgency=medium

  * debian/control:
    - Migrate Vcs-* from alioth to salsa.

 -- Roger Shimizu <rogershimizu@gmail.com>  Sun, 10 Jun 2018 18:17:46 +0900

libbloom (1.5-3) unstable; urgency=medium

  * debian/debian/libbloom1.symbols:
    - Add symbols file for libbloom1.

 -- Roger Shimizu <rogershimizu@gmail.com>  Sun, 22 Oct 2017 23:13:38 +0900

libbloom (1.5-2) unstable; urgency=medium

  * debian/watch:
    - Update to match with the filename in pristine-tar.
  * debian/tests:
    - Add upstream test suite for autopkgtest.
  * debian/control:
    - Bump up Standards-Version to 4.1.1 (with autopkgtest above).

 -- Roger Shimizu <rogershimizu@gmail.com>  Tue, 17 Oct 2017 23:58:51 +0900

libbloom (1.5-1~bpo8+1) jessie-backports-sloppy; urgency=medium

  * Rebuild for jessie-backports-sloppy.

 -- Roger Shimizu <rogershimizu@gmail.com>  Wed, 05 Jul 2017 23:12:25 +0900

libbloom (1.5-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Roger Shimizu <rogershimizu@gmail.com>  Fri, 30 Jun 2017 22:38:16 +0900

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,17 @@
 Source: libbloom
 Section: libs
 Priority: optional
-Maintainer: Roger Shimizu <rogershimizu@gmail.com>
-Build-Depends: debhelper (>= 10)
-Standards-Version: 3.9.8
+Maintainer: Debian Bridges Team <team+bridges@tracker.debian.org>
+Uploaders: Roger Shimizu <rosh@debian.org>
+Build-Depends:
+ debhelper-compat (= 12),
+ ploticus,
+ valgrind [amd64 arm64 armhf i386 mipsel mips64el powerpc ppc64 ppc64el s390x]
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: https://github.com/jvirkki/libbloom
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/libbloom.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libbloom.git
+Vcs-Git: https://salsa.debian.org/bridges-team/libbloom.git
+Vcs-Browser: https://salsa.debian.org/bridges-team/libbloom
 
 Package: libbloom-dev
 Section: libdevel

=== debian/tests/control ===
Tests: upstream-test-suite
Depends:
 build-essential,
 libbloom-dev,
 ploticus,
 valgrind [amd64 arm64 armhf i386 mipsel mips64el powerpc ppc64 ppc64el s390x]
Restrictions: allow-stderr

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libbloom_$1.orig.tar.gz%" \
   https://github.com/jvirkki/libbloom/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## libbloom 2.0

=== Makefile ===
#
# Copyright (c) 2012-2022, Jyri J. Virkki
# All rights reserved.
#
# This file is under BSD license. See LICENSE file.
#
# Requires GNU Make, so invoke appropriately (make or gmake)
#
# Other build options:
#
#   DEBUG=1 make        to build debug instead of optimized
#
# Other build targets:
#
#   make test           to build and run test code
#   make release_test   to build and run larger tests
#   make gcov           to build with code coverage and run gcov
#   make clean          the usual
#

BLOOM_VERSION_MAJOR=2
BLOOM_VERSION_MINOR=0

#
# Shared library names - these definitions work on most platforms but can
# be overridden in the platform-specific sections below.
#
BLOOM_VERSION=$(BLOOM_VERSION_MAJOR).$(BLOOM_VERSION_MINOR)
BLOOM_SONAME=libbloom.so.$(BLOOM_VERSION_MAJOR)
SO_VERSIONED=libbloom.so.$(BLOOM_VERSION)
LD_SONAME=-Wl,-soname,$(BLOOM_SONAME)
SO=so


TOP := $(shell /bin/pwd)
BUILD_OS := $(shell uname)
BINDIR=$(TOP)/build
TESTDIR=$(TOP)/misc/test

INC+=-I$(TOP) -I$(TOP)/murmur2
LIB+=-lm
CFLAGS+=-Wall
CFLAGS+=-fPIC
CFLAGS+=-DBLOOM_VERSION=$(BLOOM_VERSION)
CFLAGS+=-DBLOOM_VERSION_MAJOR=$(BLOOM_VERSION_MAJOR)
CFLAGS+=-DBLOOM_VERSION_MINOR=$(BLOOM_VERSION_MINOR)


ifeq ($(DEBUG),1)
OPT=-g $(DEBUGOPT)
else
OPT?=-O3
endif


ifeq ($(BUILD_OS),$(filter $(BUILD_OS), GNU/kFreeBSD GNU Linux))
RPATH=-Wl,-rpath,$(BINDIR)
endif

ifeq ($(BUILD_OS),SunOS)
RPATH=-R$(BINDIR)
CC=gcc
endif

ifeq ($(BUILD_OS),OpenBSD)
RPATH=-R$(BINDIR)
endif

ifeq ($(BUILD_OS),Darwin)
MAC=-install_name $(BINDIR)/libbloom.dylib \
	-compatibility_version $(BLOOM_VERSION_MAJOR) \
	-current_version $(BLOOM_VERSION)
RPATH=-Xlinker -rpath -Xlinker $(BINDIR)
SO=dylib
BLOOM_SONAME=libbloom.$(BLOOM_VERSION_MAJOR).$(SO)
SO_VERSIONED=libbloom.$(BLOOM_VERSION).$(SO)
LD_SONAME=
endif



all: $(BINDIR)/$(SO_VERSIONED) $(BINDIR)/libbloom.a

$(BINDIR)/$(SO_VERSIONED): $(BINDIR)/murmurhash2.o $(BINDIR)/bloom.o
	(cd $(BINDIR) && \
	    $(CC) $(OPT) $(LDFLAGS) bloom.o murmurhash2.o -shared \
	    $(LIB) $(MAC) $(LD_SONAME) -o $(SO_VERSIONED) && \
	rm -f $(BLOOM_SONAME) && \
	ln -s $(SO_VERSIONED) $(BLOOM_SONAME) && \
	rm -f libbloom.$(SO) && \
	ln -s $(BLOOM_SONAME) libbloom.$(SO) )

$(BINDIR)/libbloom.a: $(BINDIR)/murmurhash2.o $(BINDIR)/bloom.o
	(cd $(BINDIR) && ar rcs libbloom.a bloom.o murmurhash2.o)

$(BINDIR)/test-libbloom: $(TESTDIR)/test.c $(BINDIR)/$(SO_VERSIONED)
	$(CC) $(CFLAGS) $(OPT) $(INC) -c $(TESTDIR)/test.c -o \
	    $(BINDIR)/test.o
	(cd $(BINDIR) && \
	$(CC) $(CFLAGS) $(OPT) -L$(BINDIR) $(RPATH) test.o \
	    -lbloom -o test-libbloom)

$(BINDIR)/test-perf: $(TESTDIR)/perf.c $(BINDIR)/$(SO_VERSIONED)
	$(CC) $(CFLAGS) $(OPT) $(INC) -c $(TESTDIR)/perf.c -o $(BINDIR)/perf.o
	(cd $(BINDIR) && \
	    $(CC) perf.o -L$(BINDIR) $(RPATH) -lbloom -o test-perf)

$(BINDIR)/test-basic: $(TESTDIR)/basic.c $(BINDIR)/libbloom.a
	$(CC) $(CFLAGS) $(OPT) $(INC) $(TESTDIR)/basic.c \
	    $(BINDIR)/libbloom.a $(LIB) -o $(BINDIR)/test-basic

$(BINDIR)/visualize: $(TESTDIR)/visualize.c $(BINDIR)/libbloom.a
	$(CC) $(CFLAGS) $(OPT) $(INC) $(TESTDIR)/visualize.c \
	    $(BINDIR)/libbloom.a $(LIB) -lgd -o $(BINDIR)/visualize

$(BINDIR)/%.o: %.c
	mkdir -p $(BINDIR)
	$(CC) $(CFLAGS) $(OPT) $(INC) -c $< -o $@

$(BINDIR)/murmurhash2.o: murmur2/MurmurHash2.c murmur2/murmurhash2.h
	mkdir -p $(BINDIR)
	$(CC) $(CFLAGS) $(OPT) $(INC) \
	    -c murmur2/MurmurHash2.c -o $(BINDIR)/murmurhash2.o

clean:
	rm -rf $(BINDIR)

test: $(BINDIR)/test-libbloom $(BINDIR)/test-basic
	$(BINDIR)/test-basic
	$(BINDIR)/test-libbloom

perf: $(BINDIR)/test-perf
	$(BINDIR)/test-perf

#
# Builds the visualize program into $BINDIR
# This is not built by default as it requires the GD library
# (on Debian: libgd3 and libgd-dev) to be present.
#
visualize: $(BINDIR)/visualize

vtest: $(BINDIR)/test-libbloom
	valgrind --tool=memcheck --leak-check=full --show-reachable=yes \
	    --track-origins=yes $(BINDIR)/test-libbloom

gcov:
	$(MAKE) clean
	DEBUG=1 DEBUGOPT="-fprofile-arcs -ftest-coverage" \
	    $(MAKE) $(BINDIR)/test-libbloom
	(cd $(BINDIR) && \
	    cp ../*.c . && \
	    ./test-libbloom && \
	    gcov -bf bloom.c)
	@echo Remember to make clean to remove instrumented objects

lcov: gcov
	lcov --capture --directory build --output-file lcov.info
	lcov --remove lcov.info MurmurHash2.c --output-file lcov.info
	lcov --remove lcov.info test.c --output-file lcov.info
	genhtml lcov.info \
		--output-directory $(LCOV_OUTPUT_DIR)
	rm -f lcov.info
	$(MAKE) clean

#
# This target runs a test which creates a filter of capacity N and inserts
# N elements, for N in 100,000 to 1,000,000 with an expected error of 0.001.
# To preserve and graph the output, move it to ./misc/collisions and use
# the ./misc/collisions/dograph script to plot it.
#
# WARNING: This can take a very long time (on a slow machine, multiple days)
# to run.
#
collision_test: $(BINDIR)/test-libbloom
	$(BINDIR)/test-libbloom -G 100000 1000000 10 0.001 \
	    | tee collision_data_v$(BLOOM_VERSION)

#
# This target should be run when preparing a release, includes more tests
# than the 'test' target.
# For a final release, should run the collision_test target above as well,
# not included here as it takes so long.
#
release_test:
	$(MAKE) test
	$(MAKE) vtest
	$(BINDIR)/test-libbloom -G 100000 1000000 50000 0.001 \
	    | tee short_coll_data
	gzip short_coll_data
	./misc/collisions/dograph short_coll_data.gz

=== debian/changelog ===
libbloom (2.0-0.2build1) plucky; urgency=medium

  * Rebuild against new gcc.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 27 Feb 2025 19:33:19 +0100

libbloom (2.0-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * d/patches: add patch to fix build & tests on 32-bit platforms
  * d/control: remove arch-is-64-bit from B-D

 -- Shengqi Chen <harry-chen@outlook.com>  Sun, 27 Oct 2024 00:44:43 +0800

libbloom (2.0-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Upload to unstable.

 -- Shengqi Chen <harry-chen@outlook.com>  Fri, 25 Oct 2024 15:15:30 +0800

libbloom (2.0-0.1~exp1) experimental; urgency=medium

  * New upstream version 2.0.
  * d/patches: refresh
  * d/patches: add Forwarded headers
  * d/control: update compact level to 13, std-ver to 4.7.0
    (no changes required)
  * Bump SOVERSION to libbloom2 due to API removal
  * Disable building on 32-bit arches due to upstream limit
  * d/patches: add CPPFLAGS into CFLAGS to fix blhc issues

 -- Shengqi Chen <harry-chen@outlook.com>  Wed, 09 Oct 2024 00:48:08 +0800

libbloom (1.6-7) unstable; urgency=medium

  * Team upload.
  * debian/clean: Manually clean some generated files to fix package
    build twice in a row. (Closes: #1048826, #1049748)

 -- Boyuan Yang <byang@debian.org>  Thu, 17 Aug 2023 16:32:07 -0400

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# Security Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Add multiarch triplet include directory
include /usr/share/dpkg/architecture.mk
CFLAGS+=-I/usr/include/$(DEB_HOST_MULTIARCH)

override_dh_auto_build:
	dh_auto_build -- BITS=default

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	make BITS=default release_test
endif

override_dh_auto_install:
	mkdir -p usr/lib/$(DEB_HOST_MULTIARCH)
	cp -a build/libbloom.so* usr/lib/$(DEB_HOST_MULTIARCH)/
	dh_auto_install

%:
	dh $@
